- [HTTP request](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#body.request_body)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#body.response_body)
- [PaymentInstrument](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#PaymentInstrument)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#PaymentInstrument.SCHEMA_REPRESENTATION)
- [GetOffersResponse](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResponse)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResponse.SCHEMA_REPRESENTATION)
- [GetOffersResult](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResult)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResult.SCHEMA_REPRESENTATION)
- [AvailableOffers](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AvailableOffers)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AvailableOffers.SCHEMA_REPRESENTATION)
- [Offer](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#Offer)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#Offer.SCHEMA_REPRESENTATION)
- [AccountNotEligible](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AccountNotEligible)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AccountNotEligible.SCHEMA_REPRESENTATION)

Retrieve available offers (e.g., EMI tenures) for a given transaction amount and payment instrument.

If the endpoint encounters an error while processing the request, the response body from this endpoint should be of type `https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ErrorResponse`.

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 1
        },
        "requestId": "cmVxdWVzdDE",
        "requestTimestamp": {
          "epochMillis": "1481899949606"
        },
        "paymentIntegratorAccountId": "gsp"
      },
      "transactionAmount": {
        "amountMicros": "5000000000",
        "currencyCode": "INR"
      },
      "instrument": {
        "financingInstrument": {
          "accountNumber": "1111222233334444",
          "issuerId": {
            "value": "gsp_issuer_1"
          }
        }
      }
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": {
          "epochMillis": "1481899949611"
        }
      },
      "result": {
        "availableOffers": {
          "offers": [
            {
              "installmentPlan": {
                "threeMonths": {}
              }
            },
            {
              "installmentPlan": {
                "sixMonths": {}
              }
            }
          ]
        }
      }
    }

### HTTP request

`POST https://www.integratorhost.example.com/integrator-base-path/redirect-fop-v1/getOffers`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RequestHeader`) }, "transactionAmount": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Amount`) }, "instrument": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#PaymentInstrument`) } } ``` |

| Fields ||
|---|---|
| `requestHeader` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RequestHeader`)`` **REQUIRED**: Common header for all requests. |
| `transactionAmount` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Amount`)`` **REQUIRED**: The amount of the transaction to get offers for. |
| `instrument` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#PaymentInstrument`)`` **REQUIRED**: The payment instrument to get offers for. |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/redirect-fop-v1/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResponse`)`` |
| HTTP 4XX / 5XX Status | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ErrorResponse`)`` |
| End of mutually exclusive fields. ||

## PaymentInstrument

Details of the payment instrument for which offers are requested.

| JSON representation |
|---|
| ``` { // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "financingInstrument": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/FinancingInstrument`) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| **REQUIRED**: The payment instrument being queried for offers. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `financingInstrument` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/FinancingInstrument`)`` User's private label financing instrument. |
| End of mutually exclusive fields. ||

## GetOffersResponse

Response object for the `getOffers` method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ResponseHeader`) }, "result": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResult`) } } ``` |

| Fields ||
|---|---|
| `responseHeader` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ResponseHeader`)`` **REQUIRED**: Common header for all responses. |
| `result` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#GetOffersResult`)`` **REQUIRED** : Result details of the `getOffers` request. |

## GetOffersResult

Result details of the `getOffers` request.

| JSON representation |
|---|
| ``` { // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "availableOffers": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AvailableOffers`) }, "invalidInstrument": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Empty`) }, "insufficientFunds": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/InsufficientFunds`) }, "riskDeclined": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RiskDeclined`) }, "accountNotEligible": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AccountNotEligible`) }, "noOffersAvailable": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Empty`) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| **REQUIRED**: The result of the get offers request. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `availableOffers` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AvailableOffers`)`` Offers available for the transaction and the instrument. |
| `invalidInstrument` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Empty`)`` The provided instrument is unrecognized, malformed, expired, or does not exist with the integrator. |
| `insufficientFunds` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/InsufficientFunds`)`` The instrument does not have sufficient funds or available credit to qualify for offers for the requested amount. |
| `riskDeclined` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RiskDeclined`)`` No offers are available due to a risk check on the payment integrator's side. |
| `accountNotEligible` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#AccountNotEligible`)`` The instrument is recognized and valid, but the account is not eligible to receive offers (e.g., due to account status, credit policy, or category restrictions). |
| `noOffersAvailable` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Empty`)`` No offers are available for the transaction amount and instrument. |
| End of mutually exclusive fields. ||

## AvailableOffers

The integrator successfully retrieved offers. Details are within this message.

| JSON representation |
|---|
| ``` { "offers": [ { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#Offer`) } ] } ``` |

| Fields ||
|---|---|
| `offers[]` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/getOffers#Offer`)`` **REQUIRED**: The list of available offers for this transaction. |

## Offer

Details of an offer available for the transaction.

| JSON representation |
|---|
| ``` { // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "installmentPlan": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/InstallmentPayment`) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| **REQUIRED**: The specific type of offer. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `installmentPlan` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/InstallmentPayment`)`` An installment plan offer for the transaction. |
| End of mutually exclusive fields. ||

## AccountNotEligible

User's account is not eligible for this service.

| JSON representation |
|---|
| ``` { "rawResult": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RawResult`) } } ``` |

| Fields ||
|---|---|
| `rawResult` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RawResult`)`` **OPTIONAL** : Raw result of this event. Used to help inform Google's risk engine and analytics. In decline code--mapping situations, data is sometimes lost. The integrator can choose to give Google a raw code. For example, a credit card gateway (the integrator) may use this field to communicate to Google the exact decline code that was received from the VISA network. In that case, the `scope` would be "visa" and the `rawCode` would be whatever the VISA network returned. |